---
title: BaseAudioContext.createGain()
slug: Web/API/BaseAudioContext/createGain
tags:
  - API
  - Audio
  - AudioContext
  - BaseAudioContext
  - Method
  - Reference
  - Volume Control
  - Web Audio API
  - createGain
  - sound
---
<p>{{ APIRef("Web Audio API") }}</p>

<div>
<p>The <code>createGain()</code> method of the {{ domxref("BaseAudioContext") }} interface creates a {{ domxref("GainNode") }}, which can be used to control the overall gain (or volume) of the audio graph.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>gainNode</em> = <em>AudioContext</em>.createGain();</pre>

<h3 id="Description">Return value</h3>

<p>A {{domxref("GainNode")}} which takes as input one or more audio sources and outputs audio whose volume has been adjusted in gain (volume) to a level specified by the node's {{domxref("GainNode.gain")}} <a href="/en-US/docs/Web/API/AudioParam#a-rate">a-rate</a> parameter.</p>

<h2 id="Example">Example</h2>

<p>The following example shows basic usage of an {{domxref("AudioContext")}} to create a <code>GainNode</code>, which is then used to mute and unmute the audio when a Mute button is clicked by changing the <code>gain</code> property value.</p>

<p>The below snippet wouldn't work as is — for a complete working example, check out our <a href="https://mdn.github.io/voice-change-o-matic/">Voice-change-O-matic</a> demo (<a href="https://github.com/mdn/voice-change-o-matic/blob/gh-pages/scripts/app.js">view source</a>.)</p>

<pre class="brush: html notranslate">&lt;div&gt;
  &lt;button class="mute"&gt;Mute button&lt;/button&gt;
&lt;/div&gt;</pre>

<pre class="brush: js notranslate">var audioCtx = new (window.AudioContext || window.webkitAudioContext)();
var gainNode = audioCtx.createGain();
var mute = document.querySelector('.mute');
var source;

if (navigator.mediaDevices.getUserMedia) {
 navigator.mediaDevices.getUserMedia (
   // constraints - only audio needed for this app
   {
     audio: true
   },

   // Success callback
   function(stream) {
     source = audioCtx.createMediaStreamSource(stream);

   },

   // Error callback
   function(err) {
     console.log('The following gUM error occurred: ' + err);
   }
  );
} else {
   console.log('getUserMedia not supported on your browser!');
}

source.connect(gainNode);
gainNode.connect(audioCtx.destination);

  ...

mute.onclick = voiceMute;

function voiceMute() {
  if(mute.id == "") {
    // 0 means mute. If you still hear something, make sure you haven't
    // connected your source into the output in addition to using the GainNode.
    gainNode.gain.setValueAtTime(0, audioCtx.currentTime);
    mute.id = "activated";
    mute.textContent = "Unmute";
  } else {
    gainNode.gain.setValueAtTime(1, audioCtx.currentTime);
    mute.id = "";
    mute.textContent = "Mute";
  }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-baseaudiocontext-creategain', 'createGain()')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>
<div>

<p>{{Compat("api.BaseAudioContext.createGain")}}</p>
</div>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
